package Event_onEnterWaterBrick
{
	//Armor Methods

	function Armor::onEnterLiquid(%this,%player,%a,%b)
	{
		Parent::onEnterLiquid(%this,%player,%a,%b);

		if(%player.isEnabled() == 1)
		{
			%pos = %player.getPosition();
		
			if(%player.isCrouched())
			{
				%boxMax = vectorAdd(%player.getHackPosition(),vectorScale(%player.getDataBlock().crouchBoundingBox, 1/8));
				%boxMin = vectorSub(%player.getHackPosition(),vectorScale(%player.getDataBlock().crouchBoundingBox, 1/8));
			}
			else
			{
				%boxMax = vectorAdd(%player.getHackPosition(),vectorScale(%player.getDataBlock().boundingBox, 1/8));
				%boxMin = vectorSub(%player.getHackPosition(),vectorScale(%player.getDataBlock().boundingBox, 1/8));
			}

			%box = vectorSub(%boxMax,%boxMin);
			%waterBricks = 0;

			InitContainerBoxSearch(%pos,%box,$TypeMasks::PhysicalZoneObjectType);

			while((%checkObj = containerSearchNext()) != 0)
			{
				if(%checkObj.isWaterBrickWater == 1)
				{
					%waterBrick[%waterBricks++] = %checkObj;
				}
			}

			for(%i = 1;%i <= %waterBricks;%i++)
			{
				%water = %waterBrick[%i];
				%brick = %water.waterBrick;

				if(isObject(%brick))
				{
					if(%player.getClassName() $= "AIPlayer")
					{
						%brick.onBotEnterWater(%player.spawnBrick.getGroup().client,%player);
					}
					else if(%player.getClassName() $= "Player")
					{
						%brick.onPlayerEnterWater(%player.client);
					}
				}
			}

			if(%waterBricks > 0)
			{
				%player.inWaterBrick = 1;
				%this.whileInWaterBrick(%player,%a,%b);
			}
		}
	}

	function Armor::onLeaveLiquid(%this,%player,%a,%b)
	{
		Parent::onLeaveLiquid(%this,%player,%a,%b);

		if(%player.isEnabled() == 1)
		{
			%player.inWaterBrick = "";
		}
	}

	function Armor::whileInWaterBrick(%this,%player,%a,%b)
	{
		if(%player.isEnabled() == 1 && %player.inWaterBrick == 1)
		{
			%pos = %player.getPosition();
		
			if(%player.isCrouched())
			{
				%boxMax = vectorAdd(%player.getHackPosition(),vectorScale(%player.getDataBlock().crouchBoundingBox, 1/8));
				%boxMin = vectorSub(%player.getHackPosition(),vectorScale(%player.getDataBlock().crouchBoundingBox, 1/8));
			}
			else
			{
				%boxMax = vectorAdd(%player.getHackPosition(),vectorScale(%player.getDataBlock().boundingBox, 1/8));
				%boxMin = vectorSub(%player.getHackPosition(),vectorScale(%player.getDataBlock().boundingBox, 1/8));
			}

			%box = vectorSub(%boxMax,%boxMin);
			%waterBricks = 0;

			InitContainerBoxSearch(%pos,%box,$TypeMasks::PhysicalZoneObjectType);

			while((%checkObj = containerSearchNext()) != 0)
			{
				if(%checkObj.isWaterBrickWater == 1)
				{
					%waterBrick[%waterBricks++] = %checkObj;
				}
			}

			for(%i = 1;%i <= %waterBricks;%i++)
			{
				%water = %waterBrick[%i];
				%brick = %water.waterBrick;

				if(isObject(%brick))
				{
					if(%player.getClassName() $= "AIPlayer")
					{
						%brick.onBotInWater(%player.spawnBrick.getGroup().client,%player);
					}
					else if(%player.getClassName() $= "Player")
					{
						%brick.onPlayerInWater(%player.client);
					}
				}
			}

			if(%waterBricks > 0)
			{
				%this.schedule(200,"whileInWaterBrick",%player,%a,%b);
			}
			else
			{
				%player.inWaterBrick = "";
			}
		}
	}

	//fxDTSBrick Methods

	function fxDTSBrick::createWaterZone(%brick)
	{
		%color = getColorIDTable(%brick.colorID);
		%rgb = getWords(%color, 0, 2);
		%a = getWord(%color, 3) / 0.5;

		%pz = new PhysicalZone()
		{
			isWater = true;
			waterViscosity = 40;
			waterDensity = 1;
			waterColor = %rgb SPC %a;
			polyhedron = "0 0 0 1 0 0 0 -1 0 0 0 1";
		};

		if(!isObject(%pz))
		{
			error("ERROR: Could not create physical zone for brick8xCubeWater brick!");
			return;
		}

		missionCleanup.add(%pz);

		//set size
		%boxMin = getWords(%brick.getWorldBox(), 0, 2);
		%boxMax = getWords(%brick.getWorldBox(), 3, 5);
		%boxDiff = vectorSub(%boxMax, %boxMin);
		%boxDiff = vectorAdd(%boxDiff, "0 0 0.1"); 
		%pz.setScale(%boxDiff);

		//set position - this looks wierd because the the physical zone isn't positioned from it's center
		%posA = %brick.getWorldBoxCenter();
		%posB = %pz.getWorldBoxCenter();
		%posDiff = vectorSub(%posA, %posB);
		%posDiff = vectorSub(%posDiff, "0 0 0.1");
		%pz.setTransform(%posDiff);

		%brick.physicalZone = %pz;

		//The code above is straight from included v9 Add-On Brick_Large Cubes.zip, but here's where we add some important stuff.
		%pz.isWaterBrickWater = 1;
		%pz.waterBrick = %brick;
	}

	function fxDTSBrick::onBotEnterWater(%obj,%client,%bot)
	{
		if(isObject(%obj.physicalZone) && %obj.physicalZone.isWaterBrickWater == 1)
		{
			$InputTarget_["Self"] = %obj;
			$InputTarget_["Bot"] = %bot;

			if(isObject(%bot.getControllingClient()))
			{
				$InputTarget_["Driver(Client)"] = %bot.getControllingClient();
				$InputTarget_["Driver(Player)"] = %bot.getControllingClient().Player;
			}

			if(%client.minigame == %obj.getGroup().client.minigame)
			{
				$InputTarget_["MiniGame"] = %obj.getGroup().client.minigame;
			}

			$InputTarget_["Owner(Player)"] = %obj.getGroup().client.Player;
			$InputTarget_["Owner(Client)"] = %obj.getGroup().client;
			%obj.processInputEvent("onBotEnterWater",%client);
		}
	}

	function fxDTSBrick::onBotInWater(%obj,%client,%bot)
	{
		if(isObject(%obj.physicalZone) && %obj.physicalZone.isWaterBrickWater == 1)
		{
			$InputTarget_["Self"] = %obj;
			$InputTarget_["Bot"] = %bot;

			if(isObject(%bot.getControllingClient()))
			{
				$InputTarget_["Driver(Client)"] = %bot.getControllingClient();
				$InputTarget_["Driver(Player)"] = %bot.getControllingClient().Player;
			}

			if(%client.minigame == %obj.getGroup().client.minigame)
			{
				$InputTarget_["MiniGame"] = %obj.getGroup().client.minigame;
			}

			$InputTarget_["Owner(Player)"] = %obj.getGroup().client.Player;
			$InputTarget_["Owner(Client)"] = %obj.getGroup().client;
			%obj.processInputEvent("onBotInWater",%client);
		}
	}

	function fxDTSBrick::onPlayerEnterWater(%obj,%client)
	{
		if(isObject(%obj.physicalZone) && %obj.physicalZone.isWaterBrickWater == 1)
		{
			$InputTarget_["Self"] = %obj;
			$InputTarget_["Player"] = %client.Player;
			$InputTarget_["Client"] = %client;

			if(%client.minigame == %obj.getGroup().client.minigame)
			{
				$InputTarget_["MiniGame"] = %obj.getGroup().client.minigame;
			}

			$InputTarget_["Owner(Player)"] = %obj.getGroup().client.Player;
			$InputTarget_["Owner(Client)"] = %obj.getGroup().client;
			%obj.processInputEvent("onPlayerEnterWater",%client);
		}
	}

	function fxDTSBrick::onPlayerInWater(%obj,%client)
	{
		if(isObject(%obj.physicalZone) && %obj.physicalZone.isWaterBrickWater == 1)
		{
			$InputTarget_["Self"] = %obj;
			$InputTarget_["Player"] = %client.Player;
			$InputTarget_["Client"] = %client;

			if(%client.minigame == %obj.getGroup().client.minigame)
			{
				$InputTarget_["MiniGame"] = %obj.getGroup().client.minigame;
			}

			$InputTarget_["Owner(Player)"] = %obj.getGroup().client.Player;
			$InputTarget_["Owner(Client)"] = %obj.getGroup().client;
			%obj.processInputEvent("onPlayerInWater",%client);
		}
	}
};

activatePackage(Event_onEnterWaterBrick);

//Input Events

registerInputEvent("fxDTSBrick","onBotEnterWater","Self fxDTSBrick" TAB "Bot Player" TAB "Driver(Client) GameConnection" TAB "Driver(Player) Player" TAB "MiniGame MiniGame" TAB "Owner(Player) Player" TAB "Owner(Client) GameConnection",1);
registerInputEvent("fxDTSBrick","onBotInWater","Self fxDTSBrick" TAB "Bot Player" TAB "Driver(Client) GameConnection" TAB "Driver(Player) Player" TAB "MiniGame MiniGame" TAB "Owner(Player) Player" TAB "Owner(Client) GameConnection",1);
registerInputEvent("fxDTSBrick","onPlayerEnterWater","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame" TAB "Owner(Player) Player" TAB "Owner(Client) GameConnection",1);
registerInputEvent("fxDTSBrick","onPlayerInWater","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame" TAB "Owner(Player) Player" TAB "Owner(Client) GameConnection",1);